/*
 * Program: finger.java
 * 
 * Author: Michael Woodson
 * 
 * E-mail: n9442097@fozzie.cc.wwu.edu
 *
 * Date: March 16, 1996
 * 
 * Please send suggestions to the above e-mail address.
 * 
 * This applet is intended to be used as a learning tool for concepts in
 * binary trees.
 *
A light pen pointed at a video monitor records coordinate positions
by responding to the light emitted from phosphors on the screen.
 
 
 */


import java.awt.*;
import java.awt.image.*;
import java.applet.*;
import java.io.*;
import java.lang.*;
import java.awt.image.ImageProducer;
import java.applet.Applet;
import java.applet.AudioClip;
import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;
import java.net.URL;
import java.net.MalformedURLException;


public class finger extends Applet implements Runnable {

   static final String startstr="Start Scanning";
   static final String scanningstr="Scanning...";
   
   public static final int WIDTH = 250;
   public static final int HEIGHT = 275;
   
   public Thread btThread;
  
   public Button Scan;
   public Panel bottom, info,info2,info3;

   public btCanvas screen;
   public Label statuslabel;
   
   public int scanline;
   public int scanspeed;
   public int imgWidth, imgHeight;
   public boolean scanning = false;
   
   public Image buffer;		// For double-buffering.
   public Graphics bg;			// Buffer Graphics.  Not background.
   
   /**
     * The images, in display order (Images).
     */
    Vector images = null;

    /**
     * Duration of each image (Integers, in milliseconds).
     */
    Hashtable durations = null;

    /**
     * Sound effects for each image (AudioClips).
     */
    Hashtable sounds = null;

    /**
     * Position of each image (Points).
     */
    Hashtable positions = null;

    /**
     * MediaTracker 'class' ID numbers.
     */

    static final int STARTUP_ID    = 0;
    static final int BACKGROUND_ID = 1;
    static final int ANIMATION_ID  = 2;

    /**
     * Start-up image URL, if any.
     */
    URL startUpImageURL = null;

    /**
     * Start-up image, if any.
     */
    Image startUpImage = null;

    /**
     * Background image URL, if any.
     */
    URL backgroundImageURL = null;

    /**
     * Background image, if any.
     */
    Image backgroundImage = null;

    /**
     * Background color, if any.
     */
    Color backgroundColor = getBackground() ;
    
    /**
     * The soundtrack's URL.
     */
    URL soundtrackURL = null;

    /**
     * The soundtrack.
     */
    AudioClip soundtrack = null;

    /**
     * URL to link to, if any.
     */
    URL hrefURL = null;

    /**
     * Our width.
     */
    int appWidth = 0;

    /**
     * Our height.
     */
    int appHeight = 0;

    /**
     * Was there a problem loading the current image?
     */
    boolean imageLoadError = false;

    /**
     * The directory or URL from which the images are loaded
     */
    URL imageSource = null;

    /**
     * The directory or URL from which the sounds are loaded
     */
    URL soundSource = null;

    /**
     * The thread animating the images.
     */
    Thread engine = null;

    /**
     * The current loop slot - index into 'images.'
     */
    int frameNum;

    /**
     * frameNum as an Object - suitable for use as a Hashtable key.
     */
    Integer frameNumKey;
    
    /**
     * The current X position (for painting).
     */
    int xPos = 0;
    
    /**
     * The current Y position (for painting).
     */
    int yPos = 0;
    
    /**
     * The default number of milliseconds to wait between frames.
     */
    public static final int defaultPause = 3900;
    
    /**
     * The global delay between images, which can be overridden by
     * the PAUSE parameter.
     */
    int globalPause = defaultPause;

    /**
     * Whether or not the thread has been paused by the user.
     */
    boolean userPause = false;

    /**
     * Repeat the animation?  If false, just play it once.
     */
    boolean repeat;

    /**
     * The offscreen image, used in double buffering
     */
    Image offScrImage;

    /**
     * The offscreen graphics context, used in double buffering
     */
    Graphics offScrGC;

    /**
     * The MediaTracker we use to load our images.
     */
    MediaTracker tracker;
    
    /**
     * Can we paint yet?
     */
    boolean loaded = false;

    /**
     * Was there an initialization error?
     */
    boolean error = false;

    /**
     * What we call an image file in messages.
     */
    static final String imageLabel = "image";
    
    /**
     * What we call a sound file in messages.
     */
    static final String soundLabel = "sound";
    
    /**
     * Print silly debugging info?
     */
    static final boolean debug = true;

    /**
     * Frame in which to display applet description.
     */
    DescriptionFrame description = null;

    /**
     * Where to find the source code and documentation - for informational
     * purposes.
     */
    static final String sourceLocation =
                   "http://www.cs.upe.ac.za/staff/csalen/finger/";

    /**
     * Applet info.
     */
    public String getAppletInfo() 
    {
    	return "Internet Fingerprint Scanner v1.0 (09 Aug 1996), by Leon Nicholls";
    }

    /**
     * Show a crude "About" box.
     */
    void showDescription() 
    {
    	if (description == null) 
    	{
	      description = new DescriptionFrame();
  	    String params[][] = getParameterInfo();
	    
  	    description.tell("\t\t"+getAppletInfo()+"\n");
	      description.tell("Updates, documentation at "+sourceLocation+"\n\n");
  	    description.tell("Document base: "+getDocumentBase()+"\n");
	      description.tell("Code base: "+getCodeBase()+"\n\n");
	      description.tell("Applet parameters:\n\n");
	    
	      description.tell("width = "+super.getParameter("WIDTH")+"\n");
  	    description.tell("height = "+super.getParameter("HEIGHT")+"\n");

	      for (int i = 0; i < params.length; i++) 
	      {
    		  String name = params[i][0];
		      description.tell(name+" = "+super.getParameter(name)+"\n");
  	    }
    	}
    	description.show();
    }

    /**
     * Print silly debugging info to the standard output.
     */
    void dbg(String s) 
    {
     	if (debug) 
     	{
	      System.out.println("> "+s);
     	}
    }
    
    final int setFrameNum(int newFrameNum) 
    {
    	dbg("SetFrameNum");
    	frameNumKey = new Integer(frameNum = newFrameNum);
    	return frameNum;
    }
    
    Vector setupImages() throws MalformedURLException 
    {
    	dbg("SetupImages");

    	imageSource = new URL(getDocumentBase(),"images");
      
      startUpImageURL = new URL(getDocumentBase(),"images/start.jpg" );
    	
    	Vector result = new Vector(2);
    
	    result.addElement(new URL(getDocumentBase(),"images/finger1.jpg"));
	    result.addElement(new URL(getDocumentBase(),"images/finger2.jpg"));
	    result.addElement(new URL(getDocumentBase(),"images/finger3.jpg"));
	    result.addElement(new URL(getDocumentBase(),"images/finger4.jpg"));
	    result.addElement(new URL(getDocumentBase(),"images/finger5.jpg"));
	    result.addElement(new URL(getDocumentBase(),"images/finger6.jpg"));
	    result.addElement(new URL(getDocumentBase(),"images/finger7.jpg"));
	    
    
    	return result;
    }
    
    boolean fetchImages(Vector images) 
    {
     	dbg("FetchImages");
     	int i;
    	int size = images.size();
    
    	for (i = 0; i < size; i++) 
    	{
	      Object o = images.elementAt(i);
  	    if (o instanceof URL) 
  	    {
      		URL url = (URL)o;
      		tellLoadingMsg(url, imageLabel);
      		Image im = getImage(url);
      		tracker.addImage(im, ANIMATION_ID);
      		images.setElementAt(im, i);
	      }
   	  }  
   	
   	  try 
   	  {
	      tracker.waitForID(ANIMATION_ID);
    	} catch (InterruptedException e) {}
    
    	if (tracker.isErrorID(ANIMATION_ID)) 
    	{
	      return false;
    	}

    	return true;
    }

   Hashtable setupSounds() throws MalformedURLException 
   {
     dbg("SetupSounds");
     Hashtable result = new Hashtable();

   	 result.put(new Integer(1), new URL(getDocumentBase(),"audio/0.au"));
   	 result.put(new Integer(2), new URL(getDocumentBase(),"audio/1.au"));

     return result;
   }
   
   URL fetchSounds(Hashtable sounds) 
   {
     dbg("FetchSounds");
     for (Enumeration e = sounds.keys() ; e.hasMoreElements() ;) 
     {
	     Integer num = (Integer)e.nextElement();
	     Object o = sounds.get(num);
  	   if (o instanceof URL) 
  	   {
    	   URL file = (URL)o;
      	 tellLoadingMsg(file, soundLabel);
     	   
     	   try 
     	   {
  		    sounds.put(num, getAudioClip(file));
      	 } catch (Exception ex) 
      	 {
    		    return file;
		     }
  	   }
	   }
	   return null;
   }
   
   Dimension getImageDimensions(Image im) 
   {
	    return new Dimension(im.getWidth(null), im.getHeight(null));
   }
 
   void tellLoadingMsg(String file, String fileType) 
   {
     	//showStatus("Animator: loading "+fileType+" "+file);
   }

   void tellLoadingMsg(URL url, String fileType) 
   {
     tellLoadingMsg(url.toExternalForm(), fileType);
   }

   void clearLoadingMessage() 
   {
     showStatus("");
   }
    
   void loadError(String fileName, String fileType) 
   {
     String errorMsg = "Animator: Couldn't load "+fileType+" "+fileName;
     showStatus(errorMsg);
     System.err.println(errorMsg);
     error = true;
     repaint();
   }

   void loadError(URL badURL, String fileType) 
   {
     loadError(badURL.toExternalForm(), fileType);
   }

   void showParseError(Exception e) 
   {
     String errorMsg = "Animator: Parse error: "+e;
     showStatus(errorMsg);
     System.err.println(errorMsg);
     error = true;
     repaint();
   }
   
   public void init() 
   {
      dbg("Init");
      tracker = new MediaTracker(this);
      
      resize(WIDTH,HEIGHT);
      
      buffer = createImage(WIDTH,HEIGHT);
      bg = buffer.getGraphics();
      
      
      try
      {
      images = setupImages();
      sounds = setupSounds();
      }
      catch (MalformedURLException e) 
      {
	      showParseError(e);
	    } 
	    
      setFrameNum(0);
            
      dbg("SetLayout");
      setLayout(new BorderLayout());
      
      dbg("Panel");
      info=new Panel();
      info.add("Center",new Label("Internet Fingerprint Scanner"));
      add("North",info);
      
      dbg("new btCanvas");
      screen=new btCanvas(this);
      add("Center",screen);
           
      /*dbg("Panel3");
      info2 = new Panel();
      info2.add("Center",Scan = new Button(startstr));
            
      dbg("Panel2");
      info3=new Panel();
      info3.add("Center",statuslabel = new Label("Status"));
      */
      
      dbg("Panel3");
      bottom = new Panel();
      bottom.setLayout(new GridLayout(2,1));
      bottom.add("North",statuslabel = new Label("Status"));
      bottom.add("South",Scan = new Button(startstr));
      add("South",bottom);
      
      Scan.disable();
   }
   
   public void start() 
   {
    	if (engine == null) 
    	{
	      engine = new Thread(this);
  	    engine.start();
	    }
    	showStatus(getAppletInfo());
   }

  public void stop() 
  {
	  if (engine != null && engine.isAlive()) 
	  {
	    engine.stop();
	  }
	  engine = null;
  }

   public void run() 
   {
    	dbg("Run");
    	Thread me = Thread.currentThread();
    	URL badURL;
	
    	me.setPriority(Thread.MIN_PRIORITY);
    	statuslabel.setText("Initializing");

     	if (! loaded) 
     	{
	      try 
	      {
      		if (startUpImageURL != null) 
      		{
  		      tellLoadingMsg(startUpImageURL, imageLabel);
	    	    startUpImage = getImage(startUpImageURL);
	    	    Dimension d = getImageDimensions(startUpImage);
	    	    imgWidth = d.width;
            imgHeight = d.height;
		        tracker.addImage(startUpImage, STARTUP_ID);
    		    tracker.waitForID(STARTUP_ID);
		        if (tracker.isErrorID(STARTUP_ID)) 
		        {
        			loadError(startUpImageURL, "start-up image");
		        }

      		  // Fetch the animation frames
  	       	if (!fetchImages(images)) 
	        	{
		          Object errors[] = tracker.getErrorsAny();
  		        Image im = (Image)errors[0];
  	  	      // Need to get some kind of readable name here
  		        loadError(im+"", imageLabel);
  	  	      return;
  	  	    }

      	  	if (sounds != null) 
      	  	{
	    	      badURL = fetchSounds(sounds);
  	    	    if (badURL != null) 
  		        {
      	    		loadError(badURL, soundLabel);
  		        	return;
  	  	      }
    	  	  }

	    	    clearLoadingMessage();
     
        		loaded = true;
	         	error = false;
	        }  
	      }  
  	    catch (Exception e) 
	      {
      		error = true;
		      e.printStackTrace();
  	    }
  	    
	    }
	    
	    Scan.enable();
	    
	    statuslabel.setText("Place left thumb on left panel.");
	    screen.repaint();
    	try {Thread.sleep(scanspeed);} 
	 	  catch (InterruptedException e) {}
    	
    	while (true)
    	{
    	try 
	    {
  		  
  		  //setFrameNum(0);
        //screen.repaint();
 
	  	  if (sounds != null) 
		    {
  		  	AudioClip clip = (AudioClip)sounds.get(new Integer(1));
			    if (clip != null) 
			    {
			      clip.play();
      		 }
	  	  }
	  	  
	  	  if (screen.leftscanning)
	  	  {
	  	  
	  	    screen.leftscanning = true;
          setFrameNum(0);
          scanspeed = 40;
          scanline = 0;
          imgWidth = 100;
          imgHeight = 210;
          while (scanline<imgHeight)
        	{
  			    dbg("LScalining");
    			  screen.repaint();
       			try {Thread.sleep(scanspeed);} 
	 	    		catch (InterruptedException e) {}
    	    	scanline+=4;
     	  	}				
     		  screen.leftscanning = false;
     		  
     		  statuslabel.setText("Scan complete.");
     		  try {Thread.sleep(10*scanspeed);} 
	 	    	catch (InterruptedException e) {}
     		  
     		  statuslabel.setText("Processing image....");
     		  
     		  screen.rightscanning = true;
          setFrameNum(1);
          scanline = 0;
          while (scanline<imgHeight)
        	{
  			    dbg("RScalining");
    			  screen.repaint();
       			try {Thread.sleep(scanspeed);} 
	 	    		catch (InterruptedException e) {}
    	    	scanline+=4;
     	  	}				
     	  	
     	  	statuslabel.setText("Locating smudges....");
     		  
     		  screen.rightscanning = true;
          setFrameNum(6);
          scanline = 0;
          while (scanline<imgHeight)
        	{
  			    dbg("RScalining");
    			  screen.repaint();
       			try {Thread.sleep(scanspeed);} 
	 	    		catch (InterruptedException e) {}
    	    	scanline+=4;
     	  	}				
     	  	
     	  	
     	  	statuslabel.setText("Searching for edges....");
     		  
     		  screen.rightscanning = true;
          setFrameNum(2);
          scanline = 0;
          while (scanline<imgHeight)
        	{
  			    dbg("RScalining");
    			  screen.repaint();
       			try {Thread.sleep(scanspeed);} 
	 	    		catch (InterruptedException e) {}
    	    	scanline+=4;
     	  	}				
     	  	
     	  	screen.rightscanning = false;
     	  	screen.counting = true;
     	  	statuslabel.setText("Searching for Arches....");
     		  try {Thread.sleep(10*scanspeed);} 
	   	    catch (InterruptedException e) {}
     		  int j = (int) (Math.random()*100);
     		  for (int i=0;i<j;i++)
     		  {
       		  screen.repaint();
       		  statuslabel.setText("Searching for  Arches: "+Integer.toString(i));
       		  try {Thread.sleep(scanspeed);} 
	   	    	catch (InterruptedException e) {}
	   	    }	
	   	    screen.counting = false;
	   	    statuslabel.setText("Total Arches found: "+Integer.toString(j));
     		  try {Thread.sleep(100*scanspeed);} 
	 	    	catch (InterruptedException e) {}
     	  	
     	  	
     	  	statuslabel.setText("Analysing edges....");
     		  
     		  screen.rightscanning = true;
          setFrameNum(3);
          scanline = 0;
          while (scanline<imgHeight)
        	{
  			    dbg("RScalining");
    			  screen.repaint();
       			try {Thread.sleep(scanspeed);} 
	 	    		catch (InterruptedException e) {}
    	    	scanline+=4;
     	  	}				
     	  	
     	  	screen.rightscanning = false;
     	  	screen.counting = true;
     	  	statuslabel.setText("Searching for Loops....");
     		  try {Thread.sleep(10*scanspeed);} 
	   	    catch (InterruptedException e) {}
     		  j = (int) (Math.random()*100);
     		  for (int i=0;i<j;i++)
     		  {
       		  screen.repaint();
       		  statuslabel.setText("Searching for  Loops: "+Integer.toString(i));
       		  try {Thread.sleep(scanspeed);} 
	   	    	catch (InterruptedException e) {}
	   	    }	
	   	    screen.counting = false;
	   	    statuslabel.setText("Total Loops found: "+Integer.toString(j));
     		  try {Thread.sleep(100*scanspeed);} 
	 	    	catch (InterruptedException e) {}
     	  	
     	  	statuslabel.setText("Adjusting threshold....");
     		  
     		  screen.rightscanning = true;
          setFrameNum(4);
          scanline = 0;
          while (scanline<imgHeight)
        	{
  			    dbg("RScalining");
    			  screen.repaint();
       			try {Thread.sleep(scanspeed);} 
	 	    		catch (InterruptedException e) {}
    	    	scanline+=4;
     	  	}				
     	  	
     	  	screen.rightscanning = false;
     	  	screen.counting = true;
     	  	statuslabel.setText("Searching for Whorls....");
     		  try {Thread.sleep(10*scanspeed);} 
	   	    catch (InterruptedException e) {}
     		  j = (int) (Math.random()*100);
     		  for (int i=0;i<j;i++)
     		  {
       		  screen.repaint();
       		  statuslabel.setText("Searching for Whorls: "+Integer.toString(i));
       		  try {Thread.sleep(scanspeed);} 
	   	    	catch (InterruptedException e) {}
	   	    }	
	   	    screen.counting = false;
	   	    statuslabel.setText("Total Whorls found: "+Integer.toString(j));
     		  try {Thread.sleep(100*scanspeed);} 
	 	    	catch (InterruptedException e) {}
     	  	
     	  	statuslabel.setText("Fine tuning threshold ....");
     		  
     		  screen.rightscanning = true;
          setFrameNum(5);
          scanline = 0;
          while (scanline<imgHeight)
        	{
  			    dbg("RScalining");
    			  screen.repaint();
       			try {Thread.sleep(scanspeed);} 
	 	    		catch (InterruptedException e) {}
    	    	scanline+=4;
     	  	}				
     	  	
     		  screen.rightscanning = false;
     		  screen.counting = true;
	   	    statuslabel.setText("Searching for Ridges....");
     		  try {Thread.sleep(10*scanspeed);} 
	   	    catch (InterruptedException e) {}
     		  j = (int) (Math.random()*100);
     		  for (int i=0;i<j;i++)
     		  {
       		  screen.repaint();
       		  statuslabel.setText("Searching for Ridges: "+Integer.toString(i));
       		  try {Thread.sleep(scanspeed);} 
	   	    	catch (InterruptedException e) {}
	   	    }	
	   	    screen.counting = false;
	   	    statuslabel.setText("Total Ridges found: "+Integer.toString(j));
     		  try {Thread.sleep(100*scanspeed);} 
	 	    	catch (InterruptedException e) {}
     		  
     		  statuslabel.setText("Contacting Fingerprint Bureau....");
     		  screen.repaint();
     		  try {Thread.sleep(100*scanspeed);} 
	 	    	catch (InterruptedException e) {}
     		  
   	  	  statuslabel.setText(startstr);
         	Scan.enable(); 
         	//getAppletContext().showDocument(hrefURL);
        }
        
			  Thread.sleep(globalPause);
      } 
      catch (Exception e) 
	    {}
	    }
	  }  


   public boolean action(Event e,Object arg) 
   {
      if (startstr.equals(arg)) 
      {
      	 statuslabel.setText(scanningstr);
      	 Scan.disable();
      	 screen.leftscanning = true;

      	 return true;
      }
      
      switch (e.id) 
      {
      	case Event.MOUSE_DOWN:
	          if ((e.modifiers & Event.SHIFT_MASK) != 0) 
	          {
          		showDescription();
          		return true;
          	}	
        default:
      	    return super.handleEvent(e);  	
      }
   }
}


class btCanvas extends Canvas 
{
   finger btp;
   boolean animation = false;
   boolean leftscanning = false;
   boolean rightscanning = false;
   boolean counting = false;
   int animx,animy,animkey,oldanimx,oldanimy,bx1,by1,bx2,by2;

   public btCanvas (finger btp) 
   {
      super();
      this.btp = btp;
      btp.dbg("btCanvas");
   }

   public void update(Graphics g) 
   {
      paint(g);
   }
   
   public void paint(Graphics g) 
   {
      btp.dbg("Paint");
      
      if (!btp.loaded) 
      {
        if (btp.startUpImage != null) 
	      {
       		if (btp.tracker.checkID(btp.STARTUP_ID)) 
       		{
     		    btp.bg.setColor(Color.gray);
            btp.bg.fillRect(0,0,btp.WIDTH,btp.HEIGHT);
     		    btp.bg.drawImage(btp.startUpImage, 0, 0, this);
     		    btp.bg.setColor(Color.black);
     		    btp.bg.drawRect(0,0,btp.imgWidth,btp.imgHeight);
     		    btp.bg.drawRect(150,0,150+btp.imgWidth,btp.imgHeight);
     		    g.drawImage(btp.buffer,0,0,null);
      		}
        }  
      
      }
      else
      {
        if (rightscanning)
        {
          btp.dbg("RightScanning");
          Image imgs1 = (Image)btp.images.elementAt(0);
          Image imgs2 = (Image)btp.images.elementAt(btp.frameNum);
        
    			btp.bg.drawImage(imgs1, 0, 0, null);
    			btp.bg.setColor(Color.blue);
  	  		btp.bg.drawLine(0,btp.scanline,btp.imgWidth,btp.scanline);
  		  	btp.bg.drawLine(0,btp.scanline-1,btp.imgWidth,btp.scanline-1);
  		  	btp.bg.drawLine(0,btp.scanline-2,btp.imgWidth,btp.scanline-2);
  		  	btp.bg.drawLine(0,btp.scanline-3,btp.imgWidth,btp.scanline-3);
  		  	
  		  	btp.bg.drawImage(imgs2, 150, 0, null);
    			btp.bg.setColor(Color.blue);
  	  		btp.bg.drawLine(150,btp.scanline,150+btp.imgWidth,btp.scanline);
  		  	btp.bg.drawLine(150,btp.scanline-1,150+btp.imgWidth,btp.scanline-1);
  		  	btp.bg.drawLine(150,btp.scanline-2,150+btp.imgWidth,btp.scanline-2);
  		  	btp.bg.drawLine(150,btp.scanline-3,150+btp.imgWidth,btp.scanline-3);
  			
  			  g.clipRect(150,0,150+btp.imgWidth,btp.scanline);
    			g.drawImage(btp.buffer,0,0,null);
        
          return;
        }
        
        if (leftscanning)
        {
          btp.dbg("LeftScanning");
          Image imgs1 = (Image)btp.images.elementAt(0);
        
    			btp.bg.drawImage(imgs1, 0, 0, null);
    			btp.bg.setColor(Color.blue);
  	  		btp.bg.drawLine(0,btp.scanline,btp.imgWidth,btp.scanline);
  		  	btp.bg.drawLine(0,btp.scanline-1,btp.imgWidth,btp.scanline-1);
  		  	btp.bg.drawLine(0,btp.scanline-2,btp.imgWidth,btp.scanline-2);
  		  	btp.bg.drawLine(0,btp.scanline-3,btp.imgWidth,btp.scanline-3);
  			
  			  g.clipRect(0,0,btp.imgWidth,btp.scanline);
    			g.drawImage(btp.buffer,0,0,null);
        
          return;
        }
        
        if (counting)
        {
          btp.dbg("Counting");
          Image imgs2 = (Image)btp.images.elementAt(btp.frameNum);
        
    			btp.bg.drawImage(imgs2, 150, 0, null);
    			btp.bg.setColor(Color.blue);
    			int i = (int) (Math.random()*80) + 10;
    			int j = (int) (Math.random()*180) + 20;
  	  		btp.bg.drawLine(150+i,j-10,150+i,j+10);
  	  		btp.bg.drawLine(150+i+1,j-10,150+i+1,j+10);
  	  		btp.bg.drawLine(150+i-1,j-10,150+i-1,j+10);
  	  		btp.bg.drawLine(150+i-10,j,150+i+10,j);
  	  		btp.bg.drawLine(150+i-10,j-1,150+i+10,j-1);
  	  		btp.bg.drawLine(150+i-10,j+1,150+i+10,j+1);
  		  	
  			  g.clipRect(150,0,150+btp.imgWidth,btp.imgHeight);
    			g.drawImage(btp.buffer,0,0,null);
        
          return;
        }
      
        btp.bg.setColor(Color.gray);
        btp.bg.fillRect(0,0,btp.WIDTH,btp.HEIGHT);
     		btp.bg.drawImage(btp.startUpImage, 0, 0, this);
     		btp.bg.setColor(Color.black);
     		btp.bg.drawRect(0,0,btp.imgWidth,btp.imgHeight);
     		btp.bg.drawRect(150,0,150+btp.imgWidth,btp.imgHeight);
     		g.drawImage(btp.buffer,0,0,null);    
            
      /*
      if ((btp.images != null) && (btp.images.size() > 0) &&
        		btp.tracker.checkID(btp.ANIMATION_ID)) 
      {
     		if (btp.frameNum < btp.images.size()) 
     		{
  		    Image imgs = (Image)btp.images.elementA*t(btp.frameNum);
  		  }
  		}  
  		
  		
  		Image imgs1 = (Image)btp.images.elementAt(0);
  		Image imgs2 = (Image)btp.images.elementAt(1);
  		
  		btp.bg.setColor(Color.gray);
      btp.bg.fillRect(0,0,btp.WIDTH,btp.HEIGHT);
      btp.bg.setColor(Color.white);
              
      btp.bg.drawImage(imgs1, 0, 0, null); 
      btp.bg.drawImage(imgs2, 150, 0, null); 
      g.drawImage(btp.buffer,0,0,null);
      */
      }
   }

}

class DescriptionFrame extends Frame {

    static final int rows = 26;
    static final int cols = 70;
    
    TextArea info;

    DescriptionFrame() 
    {
     	super("Internet Fingerpring Scanner v1.0");
    	add("Center", info = new TextArea(rows, cols));
    	info.setEditable(false);
    	info.setBackground(Color.white);
    	Panel buttons = new Panel();
    	buttons.setLayout(new FlowLayout());
    	add("South", buttons);
    	buttons.add(new Button("Cancel"));
	
    	pack();
    }

    public void show() 
    {
    	info.select(0,0);
    	super.show();
    }

    void tell(String s) 
    {
     	info.appendText(s);
    }

    public boolean action(Event e, Object arg) 
    {
    	if (e.target instanceof Button) 
    	{
	      hide();
   	    return true;
    	}
    	return false;
    }
}
